Bypass Censorship Portal
========================

Self-service deployment of censorship circumvention resources.

[![Documentation](https://img.shields.io/badge/docs-latest-blue)](https://bypass.censorship.guide/)
[![Gitlab pipeline status](https://img.shields.io/gitlab/pipeline-status/guardianproject-ops/bypass-censorship/portal?branch=main)](https://gitlab.com/guardianproject-ops/bypass-censorship/portal/-/pipelines)

![Home page screenshot](docs/_static/home.png)

Development Setup
-----------------

For development, it is possible to use SQLite and a single host.
Clone this repository and navigate to it:
```
git clone https://gitlab.com/guardianproject-ops/bypass-censorship/portal
cd portal
```
Create and activate a Python virtual environment:

```
python3 -m venv venv
source ./venv/bin/activate
```

Install the Python packages needed by the application:

```
pip install -r requirements.txt
pip install psycopg2-binary
```

Set up the database:

```
flask db init
flask db upgrade
```

Before the application can be run, it will need to be configured.
Run `cp config.yaml.example config.yaml`, then edit `config.yaml` accordingly. Note that at least one cloud provider
must be configured for the application to start successfully.
To run the application:

```
flask run --host=0.0.0.0 --port=5000
```

### New frontend

To build the new portal frontend:

```
make install-frontend
```

To update the build for the new portal frontend:

```
pushd frontend && git pull --ff-only && popd && make install-frontend
```

### Docker

The dockerfile supplied will build a container to run the application:

```
docker build -t <image-name> .  

docker|podman run -e WAITRESS_THREADS=4" -e WAITRESS_RUN_HOST="0.0.0.0" -e WAITRESS_RUN_PORT="5000" -e APP="bc" -e APP_BASE="/srv" <image_name>
```

The following environment variables can be set to configure the container:

- ```WAITRESS_THREADS```: the number of Waitress worker threads for handling requests. Defaults to 4 threads.

- ```WAITRESS_RUN_HOST```: the network interfaces on which Waitress will listen on inside the container. Defaults to
  0.0.0.0 (all).

- ```WAITRESS_RUN_PORT```: the port on which Waitress will serve the application inside the container. Defaults to 5000.

- ```APP```: the app directory name, defaults to ```bc```.

- ```APP_BASE```: the base directory where the app directory will be created. Defaults to ```/srv```.

Copyright
---------

![BSD 2-clause](https://img.shields.io/badge/license-BSD%202--clause-blue)

---

Copyright 2021-2022 SR2 Communications Limited.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following
   disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

---